// CalDLL version 1.0
//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#include <stdlib.h>
#include "CalDll.h"
#pragma hdrstop
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}

//---------------------------------------------------------------------------
TKalend::TKalend()
{
TDateTime data;
unsigned short _year,_month,_day;

data = Date();
DecodeDate(data,_year,_month,_day);
YEAR = _year;
MONTH = _month;
DAY = _day;
}
//---------------------------------------------------------------------------
TKalend::TKalend(int _year, int _month, int _day)
{
YEAR = _year;
MONTH = _month;
DAY = _day;
}
//---------------------------------------------------------------------------
void TKalend::ToJulian()
{
 int Y,MM;
 div_t A,TEMP,TEMP1,TEMP2;

 A = div((14-MONTH),12);
 Y = YEAR + 4800 - A.quot;
 MM = MONTH + 12*A.quot - 3;
 TEMP = div((153*MM+2),5);
 JDN = DAY+TEMP.quot;
 JDN = JDN+365*Y;
 TEMP = div(Y,4); TEMP1 = div(Y,100); TEMP2 = div(Y,400);
 JDN = JDN + TEMP.quot - TEMP1.quot;
 JDN = JDN + TEMP2.quot - 32045;
}
//---------------------------------------------------------------------------
void TKalend::ToIslam()
{
 int N,J,L;
 //DATA ISLAMSKA
 L=JDN - 1948440 + 10632;
 N=floor((L - 1) / 10631);
 L=L-10631*N+354;
 J=(floor((10985-L)/5316)*floor((50*L)/17719))+(floor(L/5670)*floor((43*L)/15238));
 L=L-(floor((30-J)/15)*floor((17719*J)/50))-(floor(J/16)*floor((15238*J)/43))+29;
 ISLAM_MONTH=floor((24*L)/709);
 ISLAM_DAY=L-floor((709*ISLAM_MONTH)/24);
 ISLAM_YEAR=30*N+J-30;
 switch (ISLAM_MONTH)
 {
  case 1 : ISLAM_MONTH_NAME="MuHarram"; break;
  case 2 : ISLAM_MONTH_NAME="Safar"; break;
  case 3 : ISLAM_MONTH_NAME="Rabi al-awal"; break;
  case 4 : ISLAM_MONTH_NAME="Rabi al-THany"; break;
  case 5 : ISLAM_MONTH_NAME="Jumaada al-awal"; break;
  case 6 : ISLAM_MONTH_NAME="Jumaada al-THaany"; break;
  case 7 : ISLAM_MONTH_NAME="Rajab"; break;
  case 8 : ISLAM_MONTH_NAME="SHa ban"; break;
  case 9 : ISLAM_MONTH_NAME="RamaDHaan"; break;
  case 10 : ISLAM_MONTH_NAME="SHawwal"; break;
  case 11 : ISLAM_MONTH_NAME="Thw al-Qi dah"; break;
  case 12 : ISLAM_MONTH_NAME="Thw al-Hijjah"; break;
 }
};
//---------------------------------------------------------------------------
int TKalend::Remainder(int x, int y)
{
 int wynik;
 if (x<0) wynik = x - y * floor(x/y);
     else wynik = x - y * ceil(x/y);
 return wynik;
}
//---------------------------------------------------------------------------
void TKalend::RoshHashannah(int ROK, int &Dzien_RH, int &Mies_RH)
{
 double Fraction;
 double Cz_Ulamk;
 int Dzien_Tyg,G,Temp1;
 TDateTime Data_RH;

 G = fmod(ROK,19) + 1;
 Fraction = (floor(ROK/100)-floor(ROK/400)-2);
 Fraction = Fraction + (765433.0/492480.0*Remainder(12*G,19));
 Fraction = Fraction + Remainder(ROK,4)/4.0;
 Fraction = Fraction - (313*ROK+89081)/98496.0;
 //--- POSTPONED RULES ---}
 Mies_RH = 9;
 if (Fraction>30)
    {
        Dzien_RH=fmod(floor(Fraction),30);
        Mies_RH++;
    } else Dzien_RH=floor(Fraction);
 Data_RH = EncodeDate((Word)ROK,(Word)Mies_RH,(Word)Dzien_RH);
 Dzien_Tyg = DayOfWeek(Data_RH);
 //----
 Temp1 = floor(Fraction);
 Cz_Ulamk = Fraction - Temp1;
 //----
 //Zasada 1
 if ((Dzien_Tyg == 1) || (Dzien_Tyg == 4) || (Dzien_Tyg == 6)) {Dzien_RH++;}
 if (Dzien_RH>30) {Dzien_RH=fmod(Dzien_RH,30); Mies_RH++;}
 //Zasada 2
 if ((Dzien_Tyg = 2) && (Cz_Ulamk>=0.897723765) && (Remainder(12*G,19)>11)) {Dzien_RH++;}
 if (Dzien_RH>30) {Dzien_RH=fmod(Dzien_RH,30); Mies_RH++;}
 //Zasada 3
 if ((Dzien_Tyg == 3) && (Cz_Ulamk>=0.63287037) && (Remainder(12*G,19)>6)) {Dzien_RH++; Dzien_RH++;}
 if (Dzien_RH>30) {Dzien_RH=fmod(Dzien_RH,30); Mies_RH++;}
}
//---------------------------------------------------------------------------
void TKalend::ToHebr()
{
 int AKT_ROK,AKT_MIES,AKT_DZIEN;
 int Dzien_RH,Dzien_RH_N,Mies_RH,Mies_RH_N,Rok_RH;
 int Suma,Zapas,Roznica_do_dzis,Roznica,JulianRH,JulianRH1,Dzisiaj;
 int Rok_H[7][14];
 int T,Konf,Mies;
 AKT_ROK = YEAR;
 AKT_MIES = MONTH;
 AKT_DZIEN = DAY;
 //--353--
 Rok_H[1][1]=30; Rok_H[1][2]=29;  Rok_H[1][3]=29;  Rok_H[1][4]=29;
 Rok_H[1][5]=30; Rok_H[1][6]=29;  Rok_H[1][7]=30;  Rok_H[1][8]=29;
 Rok_H[1][9]=30; Rok_H[1][10]=29; Rok_H[1][11]=30; Rok_H[1][12]=29;
 //--354--
 Rok_H[2][1]=30; Rok_H[2][2]=29;  Rok_H[2][3]=30;  Rok_H[2][4]=29;
 Rok_H[2][5]=30; Rok_H[2][6]=29;  Rok_H[2][7]=30;  Rok_H[2][8]=29;
 Rok_H[2][9]=30; Rok_H[2][10]=29; Rok_H[2][11]=30; Rok_H[2][12]=29;
 //--355--
 Rok_H[3][1]=30; Rok_H[3][2]=30;  Rok_H[3][3]=30;  Rok_H[3][4]=29;
 Rok_H[3][5]=30; Rok_H[3][6]=29;  Rok_H[3][7]=30;  Rok_H[3][8]=29;
 Rok_H[3][9]=30; Rok_H[3][10]=29; Rok_H[3][11]=30; Rok_H[3][12]=29;
 //--383--
 Rok_H[4][1]=30;  Rok_H[4][2]=29;  Rok_H[4][3]=29;  Rok_H[4][4]=29;
 Rok_H[4][5]=30;  Rok_H[4][6]=30;  Rok_H[4][7]=29;  Rok_H[4][8]=30;  Rok_H[4][9]=29;
 Rok_H[4][10]=30; Rok_H[4][11]=29; Rok_H[4][12]=30; Rok_H[4][13]=29;
 //--384--
 Rok_H[5][1]=30;  Rok_H[5][2]=29;  Rok_H[5][3]=30;  Rok_H[5][4]=29;
 Rok_H[5][5]=30;  Rok_H[5][6]=30;  Rok_H[5][7]=29;  Rok_H[5][8]=30;  Rok_H[5][9]=29;
 Rok_H[5][10]=30; Rok_H[5][11]=29; Rok_H[5][12]=30; Rok_H[5][13]=29;
 //--385--
 Rok_H[6][1]=30;  Rok_H[6][2]=30;  Rok_H[6][3]=30;  Rok_H[6][4]=29;
 Rok_H[6][5]=30;  Rok_H[6][6]=30;  Rok_H[6][7]=29;  Rok_H[6][8]=30;  Rok_H[6][9]=29;
 Rok_H[6][10]=30; Rok_H[6][11]=29; Rok_H[6][12]=30; Rok_H[6][13]=29;

 Rok_RH=AKT_ROK;
 RoshHashannah(Rok_RH,Dzien_RH,Mies_RH);
 if (Mies_RH==AKT_MIES) {Rok_RH--;}
 if (Mies_RH>AKT_MIES) {Rok_RH--;}
 RoshHashannah(Rok_RH,Dzien_RH,Mies_RH);
 //--- Wyliczenie dl. roku ---
 RoshHashannah(Rok_RH+1,Dzien_RH_N,Mies_RH_N);
 JulianRH = GregorToJulian(Rok_RH,Mies_RH,Dzien_RH);
 JulianRH1 = GregorToJulian(Rok_RH+1,Mies_RH_N,Dzien_RH_N);
 Roznica = JulianRH1-JulianRH;
 //--- Ile dni do DZISIAJ ---
 Dzisiaj = GregorToJulian(AKT_ROK,AKT_MIES,AKT_DZIEN);
 Roznica_do_dzis = Dzisiaj - JulianRH;
 //--- Konfiguracja miesiecy ---
 if (Roznica == 353) {Konf=1;}
 if (Roznica == 354) {Konf=2;}
 if (Roznica == 355) {Konf=3;}
 if (Roznica == 383) {Konf=4;}
 if (Roznica == 384) {Konf=5;}
 if (Roznica == 385) {Konf=6;}
 //--- Obliczanie dnia ---
 Zapas = Roznica_do_dzis;
 Mies = 1;
 do
 {
  Zapas=Zapas-Rok_H[Konf][Mies];
  Mies++;
 } while (Zapas>0);
 Mies--;
 Suma=0;
 for (T=1; T<=Mies-1; T++) {Suma=Suma+Rok_H[Konf][T];}
 HEB_DAY=Roznica_do_dzis - Suma + 1;
 if (Mies == 1) {HEB_MONTH="Tishri";}
 if (Mies == 2) {HEB_MONTH="Heshvan";}
 if (Mies == 3) {HEB_MONTH="Kislev";}
 if (Mies == 4) {HEB_MONTH="Tevet";}
 if (Mies == 5) {HEB_MONTH="Shevat";}
 if (Mies == 6) {HEB_MONTH="Adar";}
 if (Mies == 7) {if ((Roznica == 383) || (Roznica == 384) || (Roznica == 385)) {HEB_MONTH="Adar";} else {HEB_MONTH="Nisan";}}
 if (Mies == 8) {if ((Roznica == 383) || (Roznica == 384) || (Roznica == 385)) {HEB_MONTH="Nisan";} else {HEB_MONTH="Iyar";}}
 if (Mies == 9) {if ((Roznica == 383) || (Roznica == 384) || (Roznica == 385)) {HEB_MONTH="Iyar";} else {HEB_MONTH="Sivan";}}
 if (Mies == 10) {if ((Roznica == 383) || (Roznica == 384) || (Roznica == 385)) {HEB_MONTH="Sivan";} else {HEB_MONTH="Tammuz";}}
 if (Mies == 11) {if ((Roznica == 383) || (Roznica == 384) || (Roznica == 385)) {HEB_MONTH="Tammuz";} else {HEB_MONTH="Av";}}
 if (Mies == 12) {if ((Roznica == 383) || (Roznica == 384) || (Roznica == 385)) {HEB_MONTH="Av";} else {HEB_MONTH="Elul";}}
 if (Mies == 13) {HEB_MONTH="Elul";}
 //--- Okreslenie roku ---
 HEB_YEAR=Rok_RH + 3761;
}
//---------------------------------------------------------------------------
int TKalend::GregorToJulian(int rok_, int miesiac_, int dzien_)
{
 int Y,MM;
 div_t A,TEMP,TEMP1,TEMP2;
 A = div((14-miesiac_),12);
 Y = rok_ + 4800 - A.quot;
 MM = miesiac_ + 12*A.quot - 3;
 TEMP = div((153*MM+2),5);
 JDN = dzien_+TEMP.quot;
 JDN = JDN+365*Y;
 TEMP = div(Y,4);
 TEMP1 = div(Y,100);
 TEMP2 = div(Y,400);
 JDN = JDN + TEMP.quot - TEMP1.quot;
 JDN = JDN + TEMP2.quot - 32045;
 return JDN;
}
//---------------------------------------------------------------------------
void TKalend::Day_Of_Year()
{
 TDateTime DZIS,POCZATEK;

 DZIS = EncodeDate(YEAR,MONTH,DAY);
 POCZATEK = EncodeDate(YEAR,1,1);
 DAY_OF_YEAR = DZIS - POCZATEK + 1;
}
//---------------------------------------------------------------------------
void TKalend::Leap_Years()
{
 if ((YEAR % 4 == 0) && !(YEAR % 100 == 0)) {LEAP_YEAR = true;} else {LEAP_YEAR = false;}
 if (YEAR % 400 == 0) {LEAP_YEAR = true;}
}
//---------------------------------------------------------------------------
void TKalend::Count_Days_To_From()
{
TDateTime Dzis,Dzien_Pierwszy,Dzien_Ostatni;

Dzis = EncodeDate(YEAR,MONTH,DAY);
Dzien_Pierwszy = EncodeDate(YEAR,1,1);
Dzien_Ostatni = EncodeDate(YEAR,12,31);

To_Day = Dzis - Dzien_Pierwszy + 1;
From_Day = Dzien_Ostatni - Dzis;
}
//---------------------------------------------------------------------------
void TKalend::ToEgipt()
{
 TDateTime DATA,DPocz,DKon;

 DATA=EncodeDate(YEAR,MONTH,DAY);
 //--Czy Thuout--
 DPocz=EncodeDate(YEAR,9,11); DKon=EncodeDate(YEAR,10,10);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Thuout"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Paopi--
 DPocz=EncodeDate(YEAR,10,11); DKon=EncodeDate(YEAR,9,9);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Paopi"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Athor--
 DPocz=EncodeDate((Word)YEAR,11,10); DKon=EncodeDate((Word)YEAR,12,10);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Athor"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Khoiak--
 DPocz=EncodeDate((Word)YEAR,1,1); DKon=EncodeDate((Word)YEAR,1,9);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Khoiak"; EGIPT_DAY=floor(DATA-DPocz)+21; }
 //--Czy Khoiak--
 DPocz=EncodeDate((Word)YEAR,12,10); DKon=EncodeDate((Word)YEAR,12,31);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Khoiak"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Tobi--
 DPocz=EncodeDate((Word)YEAR,1,9); DKon=EncodeDate((Word)YEAR,2,7);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Tobi"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Mekhir--
 DPocz=EncodeDate((Word)YEAR,2,8); DKon=EncodeDate((Word)YEAR,9,3);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Ekhit"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Farmeno--
 DPocz=EncodeDate(YEAR,3,10); DKon=EncodeDate(YEAR,4,8);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Farmeno"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Farmou--
 DPocz=EncodeDate(YEAR,4,9); DKon=EncodeDate(YEAR,5,8);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Farmou"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Pakhon--
 DPocz=EncodeDate(YEAR,5,9); DKon=EncodeDate(YEAR,6,7);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Pakhon"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Paony--
 DPocz=EncodeDate(YEAR,6,8); DKon=EncodeDate(YEAR,7,7);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Paony"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Epep--
 DPocz=EncodeDate(YEAR,7,8); DKon=EncodeDate(YEAR,8,6);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Epep"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Mesori--
 DPocz=EncodeDate(YEAR,8,7); DKon=EncodeDate(YEAR,9,5);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Mesori"; EGIPT_DAY=floor(DATA-DPocz); }
 //--Czy Nasie--
 DPocz=EncodeDate(YEAR,9,6); DKon=EncodeDate(YEAR,9,10);
 if ((DATA >= DPocz) && (DATA <= DKon)) { EGIPT_MONTH_NAME="Nasie"; EGIPT_DAY=floor(DATA-DPocz); }
 EGIPT_YEAR=YEAR - 284;
}
//---------------------------------------------------------------------------
void TKalend::ToEtiopia()
{
 TDateTime DATA,DPocz,DKon;

 DATA=EncodeDate(YEAR,MONTH,DAY);
 //-Czy Meskerem--}
 DPocz=EncodeDate(YEAR,9,11); DKon=EncodeDate(YEAR,10,10);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Meskerem"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Tikemet--}
 DPocz=EncodeDate(YEAR,10,11); DKon=EncodeDate(YEAR,9,9);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Tikemet"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Hidar--}
 DPocz=EncodeDate(YEAR,11,10); DKon=EncodeDate(YEAR,12,10);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Hidar"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Tehesas--}
 DPocz=EncodeDate(YEAR,1,1); DKon=EncodeDate(YEAR,1,9);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Tehesas"; ETIOPIA_DAY=floor(DATA-DPocz)+21; }
 //-Czy Tehesas--}
 DPocz=EncodeDate(YEAR,12,10); DKon=EncodeDate(YEAR,12,31);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Tehesas"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Tir--}
 DPocz=EncodeDate(YEAR,1,9); DKon=EncodeDate(YEAR,2,7);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Tir"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Yekahit--}
 DPocz=EncodeDate(YEAR,2,8); DKon=EncodeDate(YEAR,9,3);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Yekahit"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Megabit--}
 DPocz=EncodeDate(YEAR,3,10); DKon=EncodeDate(YEAR,4,8);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Megabit"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Miyaza--}
 DPocz=EncodeDate(YEAR,4,9); DKon=EncodeDate(YEAR,5,8);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Miyaza"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Ginbot--}
 DPocz=EncodeDate(YEAR,5,9); DKon=EncodeDate(YEAR,6,7);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Ginbot"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Sene--}
 DPocz=EncodeDate(YEAR,6,8); DKon=EncodeDate(YEAR,7,7);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Sene"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Hamle--}
 DPocz=EncodeDate(YEAR,7,8); DKon=EncodeDate(YEAR,8,6);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Hamle"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Nehase--}
 DPocz=EncodeDate(YEAR,8,7); DKon=EncodeDate(YEAR,9,5);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Nehase"; ETIOPIA_DAY=floor(DATA-DPocz); }
 //-Czy Pagume--}
 DPocz=EncodeDate(YEAR,9,6); DKon=EncodeDate(YEAR,9,10);
 if ((DATA >= DPocz) && (DATA <= DKon))  { ETIOPIA_MONTH_NAME="Pagume"; ETIOPIA_DAY=floor(DATA-DPocz); }
 ETIOPIA_YEAR=YEAR - 8;
}
//---------------------------------------------------------------------------
void TKalend::ToAztec()
{
 int DiasMes[22];
 AnsiString NobreDia[22],NobreAzt[21],NobreAno[5],NobreCAzt[5];
 int TotalDias,cons,princano,primdias,cat,cac,cdt,cdv;

 MONTH--;
 DiasMes[1]=0;    DiasMes[2]=31;   DiasMes[3]=59;
 DiasMes[4]=90;   DiasMes[5]=120;  DiasMes[6]=151;
 DiasMes[7]=181;  DiasMes[8]=212;  DiasMes[9]=243;
 DiasMes[10]=273; DiasMes[11]=304; DiasMes[12]=334;
 NobreDia[1]="rabbit";      NobreDia[2]="water";     NobreDia[3]="dog";
 NobreDia[4]="monkey";      NobreDia[5]="herb";      NobreDia[6]="cane";
 NobreDia[7]="tiger";       NobreDia[8]="eagle";     NobreDia[9]="buzzard";
 NobreDia[10]="earthquake"; NobreDia[11]="knife";    NobreDia[12]="rain";
 NobreDia[13]="flower";     NobreDia[14]="aligator"; NobreDia[15]="wind";
 NobreDia[16]="home";       NobreDia[17]="home";     NobreDia[18]="lizard";
 NobreDia[19]="snake";      NobreDia[20]="death";    NobreDia[21]="stag";
 NobreAzt[1]="tochtli";    NobreAzt[2]="atl";           NobreAzt[3]="itzcuintli";
 NobreAzt[4]="ozomatli";   NobreAzt[5]="malinalli";    NobreAzt[6]="acatl";
 NobreAzt[7]="ocelotl";    NobreAzt[8]="cuauhtli";     NobreAzt[9]="cozcacuauthli";
 NobreAzt[10]="ollin";     NobreAzt[11]="tecpatl";     NobreAzt[12]="quiahuitl";
 NobreAzt[13]="xochitl";   NobreAzt[14]="cipactli";    NobreAzt[15]="ehecatl";
 NobreAzt[16]="calli";     NobreAzt[17]="cuetzpallin"; NobreAzt[18]="coatl";
 NobreAzt[19]="miquiztli"; NobreAzt[20]="mazatl";
 NobreAno[1]="rabbit"; NobreAno[2]="cane"; NobreAno[3]="knife"; NobreAno[4]="home";
 NobreCAzt[1]="tochtli"; NobreCAzt[2]="acatl"; NobreCAzt[3]="tecpatl"; NobreCAzt[4]="calli";

 TotalDias=DAY+DiasMes[MONTH+1];
 if (YEAR<1581) {cons=123; princano=33;} else
             {cons=133; princano=43;}
 if (TotalDias<princano) {primdias=1;} else {primdias=0;}

 cat=((YEAR-1974)-13*floor((YEAR-1974)/13))+1;
 cac=((YEAR-1974)-4*floor((YEAR-1974)/4))+1;
 cdt=((TotalDias-cons)-13*floor(((float)TotalDias-(float)cons)/13))+cat;
 cdv=((TotalDias-cons)-20*floor(((float)TotalDias-(float)cons)/20))+(cac*5-4);
 cac=cac-primdias;
 cat=cat-primdias;
 if (cat<1) {cat=cat+13;}
 if (cac<1) {cac=cac+4;}
 if (cdt>13) {cdt=cdt-13;}
 if (cdv>20) {cdv=cdv-20;}
 AnoTrace=cat;
 AnoCuatro=NobreAno[cac];
 DiaTrece=cdt;
 DiaVeinte=NobreDia[cdv];
 AztecName=NobreAzt[cdv];
 AztecNom=NobreCAzt[cac];

 Aztec_Year = (AnsiString) AnoTrace + " " + AnoCuatro + " in nahautl " + AztecNom;
 Aztec_Day = (AnsiString) DiaTrece + " " + DiaVeinte + " in nahautl " + AztecName;
 MONTH++;
}
//---------------------------------------------------------------------------
void TKalend::ToTybet()
{
AnsiString Element[5] = {"Ogie","Ziemia","elazo","Woda","Drzewo"};
AnsiString Animals[12] = {"Zajc","Smok","W","Ko","Owca","Mapa","Ptak","Pies","winia","Mysz","Osio","Tygrys"};
int k,i,e,a;

if (YEAR % 2 == 0) {i = (YEAR+4) % 10;} //jeeli parzysty
if (YEAR % 2 != 0) {i = ((YEAR+4) % 10) - 1;} //jeeli nieparzysty
e = floor(0.5 * i);
a = (YEAR + 5) % 12;

k = 0;
do {k++;} while ((60 * k) <= (YEAR - 967));

Tybet_Year = "("+Element[e]+","+Animals[a]+","+IntToStr(k)+")";
}
//---------------------------------------------------------------------------
